import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;

/**
 * HelloJavaGame
 */
public class HelloJavaGame {

	/** 自機X */
	private int x = 400;

	/** 自機Y */
	private int y = 500;

	/** ミサイルX */
	private int mx = -1;

	/** ミサイルY */
	private int my = -1;

	/** 敵機X */
	private int[] tekix = new int[2];

	/** 敵機Y */
	private int[] tekiy = new int[2];

	/** 敵機一覧 */
	private JComponent[] tekis = new JComponent[2];

	/** ラベル */
	private JLabel label1 = null;
	private JLabel label2 = null;

	/** テキストフィールド */
	JTextField field = null;

	/** ボタンの生成 */
	JButton button = null;

	// ボタンを押した回数
	private int countButton = 0;

	/** キーを押している状態一覧 */
	private boolean[] keyPressTbl = null;

	/** タイマー */
	private java.util.Timer timerThis = null;

	/**
	 * ここからはじまります。
	 */
	public static void main(String[] args){
		HelloJavaGame hg = new HelloJavaGame();
	}

	/**
	 * コンストラクタ
	 */
	public HelloJavaGame(){

		// フレームを生成
		JFrame frame = new JFrame("Hello Java Game!!");

		// ×ボタンが押されたら、終了する
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		// レイアウト
		frame.setLayout(new BorderLayout());

		// パネルを生成
		JPanel panel = new JPanel();

		// パネルサイズを設定
		panel.setPreferredSize(new Dimension(800, 600));
		// レイアウト設定
		panel.setLayout(null);

		// フレームにパネルを設定
		frame.setContentPane(panel);

		// ラベルを生成
		label1 = new JLabel("Java");

		// フォントの設定
		label1.setFont(new Font("ＭＳ ゴシック", Font.BOLD, 24));

		// パネルにラベルを追加
		panel.add(label1);

		// ラベルの位置を設定
		label1.setBounds(100, 100, 56, 30);

		// ラベルを生成
		label2 = new JLabel("v(^_^)");

		// フォントの設定
		label2.setFont(new Font("ＭＳ ゴシック", Font.BOLD, 48));

		// パネルにラベルを追加
		panel.add(label2);

		// ラベルの色を設定
		label2.setForeground(new Color(255, 96, 0));

		// ラベルの位置を設定
		label2.setBounds(x, y, 160, 50);

		// テキストフィールドの生成
		field = new JTextField("(#｀´#)");

		// フォントの設定
		field.setFont(new Font("ＭＳ ゴシック", Font.BOLD, 28));

		// パネルにテキストフィールドを追加
		panel.add(field);

		// テキストフィールドの位置を設定
		field.setBounds(180, 300, 128, 32);

		// ボタンの生成
		button = new JButton("ぼたん");

		// イメージアイコンの生成
		ImageIcon imageicon = new ImageIcon("./teki.png");

		// アイコンをセット
		button.setIcon(imageicon);

		// パネルにボタンを追加
		panel.add(button);

		// ボタンの位置を設定
		button.setBounds(180, 400, 128, 32);

		// ボタンを押した
		button.addActionListener((e) -> {
			// カウント数＋１
			countButton++;
			// テキストフィールドに表示
			field.setText("きみ、ボタン、押したね " + countButton + " 回目");
		});

		// 敵機一覧に敵機を設定
		tekis[0] = field;
		tekis[1] = button;
		tekiy[0] = 800;
		tekiy[1] = 800;

		// フレームを表示
		frame.setVisible(true);
		// サイズを最適化する
		frame.pack();

		// キーイベントを登録
		panel.addKeyListener(new HelloJavaGameKeyAdapter());

		// キー押下状況一覧を生成
		keyPressTbl = new boolean[256];

		// タイマーを生成
		timerThis = new java.util.Timer();

		// タイマーをスタート
		timerThis.scheduleAtFixedRate(new TimerActionListener(), 1l, 4l);

		// パネルにフォーカスを当てる
		panel.requestFocus();

	} // end HelloJavaGame

	/**
	 * 実行
	 */
	public void run(){

		//
		// 自機
		//

		// 右
		if(this.isKeyCodePressed(KeyEvent.VK_RIGHT)){
			if(x < 640){
				x = x + 2;
				label2.setText("(^_^)v");
			}
		}

		// 左
		if(this.isKeyCodePressed(KeyEvent.VK_LEFT)){
			if(x > 0){
				x = x - 2;
				label2.setText("v(^_^)");
			}
		}

		// ラベルの位置を設定
		label2.setBounds(x, y, 160, 50);

		//
		// ミサイル
		//

		// スペース
		if(this.isKeyCodePressed(KeyEvent.VK_SPACE)){

			// ミサイルが存在しない場合、
			if(mx == -100){
				// ミサイルの位置を初期化
				mx = x + 50;
				my = y - 20;
			}

		} // end if スペース

		// ミサイルが存在する場合、
		if(mx != -100){

			// ミサイルを移動
			my = my - 4;

			// 画面の外に出た場合、
			if(my < -20){
				// ミサイルは存在しない
				mx = -100;
				my = -100;
			}

			// ミサイルの位置を設定
			label1.setBounds(mx, my, 56, 20);

		} // end if ミサイルが存在する場合

		// 敵機一覧の件数分、ループ
		for(int i = 0; i < tekis.length; i++){

			// 移動
			tekiy[i] = tekiy[i] + 2;

			// 下まで行った場合、
			if(tekiy[i] > 600){
				// 初期化
				tekix[i] = (int)(Math.random() * 672);
				tekiy[i] = -32;
			}

			// ボタンの位置を設定
			tekis[i].setBounds(tekix[i], tekiy[i], 128, 32);

		} // end for 敵機一覧の件数分、ループ

	} // end run

	/**
	 * キー押下中かをどうかをチェック
	 * @param keyCode キーコード
	 * @return boolean true：押している ／ false：押していない
	 */
	public boolean isKeyCodePressed(int keyCode){

		return keyPressTbl[keyCode];

	} // end isKeyCodePressed

	/**
	 * キーアダプタークラス
	 */
	private class HelloJavaGameKeyAdapter extends KeyAdapter{

		public void keyPressed(KeyEvent ke){
			int code = ke.getKeyCode();
			if(code < 256){
				keyPressTbl[code] = true;
			}
		}

		public void keyReleased(KeyEvent ke){
			int code = ke.getKeyCode();
			if(code < 256){
				keyPressTbl[code] = false;
			}
		}

	} // HelloJavaGameKeyAdapterapter

	/**
	 * タイマークラス
	 */
	private class TimerActionListener extends TimerTask {

		public void run(){

			// 実行メソッド呼び出し
			HelloJavaGame.this.run();

		} // end actionPerformed

	} // end TimerActionListener

}
